/**
 * 
 */
package net.bigeon.gclc.process;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import net.bigeon.gclc.process.mocks.CommandMock;

/**
 * @author Emmanuel Bigeon
 *
 */
public class ForkCommandTaskTest {

    /** Test method for
     * {@link net.bigeon.gclc.process.ForkCommandTask#ForkCommandTask(net.bigeon.gclc.command.ICommand, java.lang.String[], int)}.
     * 
     * @throws InterruptedException if there is an error in the thread join */
    @Test
    public void testForkCommandTask() throws InterruptedException {
        final CommandMock cmd = new CommandMock();
        final ForkCommandTask task = new ForkCommandTask(cmd, new String[0], 1);

        final Thread th = new Thread(task);
        th.start();
        th.join();

        assertEquals("Task should be executed once", 1, cmd.getExecuteCall());
        assertEquals("Names should be consistent between task and command",
                cmd.getCommandName(), task.getName());
    }
}
